org.apache.hc.client5.http.async

## Interface AsyncExecRuntime

    @Internal
    public interface AsyncExecRuntime

Execution runtime that provides access to the underlying connection endpoint and helps manager its life cycle.

This interface is considered internal and generally ought not be used or accessed by custom request exec handlers.

Since:
  5.0

### Method Summary

Methods
`void` `acquireConnection(HttpRoute route, Object state, HttpClientContext clientContext, org.apache.hc.core5.concurrent.FutureCallback<AsyncExecRuntime> callback)`
`void` `connect(HttpClientContext clientContext, org.apache.hc.core5.concurrent.FutureCallback<AsyncExecRuntime> callback)`
`void` `discardConnection()`
`void` `execute(org.apache.hc.core5.http.nio.AsyncClientExchangeHandler exchangeHandler, HttpClientContext context)` Initiates a message exchange using the given handler.
`boolean` `isConnected()`
`boolean` `isConnectionAcquired()`
`void` `markConnectionNonReusable()`
`void` `markConnectionReusable(Object state, org.apache.hc.core5.util.TimeValue duration)`
`void` `releaseConnection()`
`void` `upgradeTls(HttpClientContext context)`
`boolean` `validateConnection()`

### Method Detail

#### isConnectionAcquired

    boolean isConnectionAcquired()

#### acquireConnection

    void acquireConnection(HttpRoute route,
                         Object state,
                         HttpClientContext clientContext,
                         org.apache.hc.core5.concurrent.FutureCallback<AsyncExecRuntime> callback)

#### releaseConnection

    void releaseConnection()

#### discardConnection

    void discardConnection()

#### validateConnection

    boolean validateConnection()

#### isConnected

    boolean isConnected()

#### connect

    void connect(HttpClientContext clientContext,
               org.apache.hc.core5.concurrent.FutureCallback<AsyncExecRuntime> callback)

#### upgradeTls

    void upgradeTls(HttpClientContext context)

#### execute

    void execute(org.apache.hc.core5.http.nio.AsyncClientExchangeHandler exchangeHandler,
               HttpClientContext context)

Initiates a message exchange using the given handler.

#### markConnectionReusable

    void markConnectionReusable(Object state,
                              org.apache.hc.core5.util.TimeValue duration)

#### markConnectionNonReusable

    void markConnectionNonReusable()